require 'json'

class CuvvaError < StandardError
	attr_accessor :code
	attr_accessor :reasons
	attr_accessor :meta
	attr_reader :stack

	def initialize(*args)
		code, reasons, meta = args

		if meta === nil && !reasons.is_a?(Array)
			meta = reasons
			reasons = nil
		end

		@code = code
		@reasons = reasons
		@meta = meta
		@stack = caller
	end

	def to_hash
		{
			code: self.code,
			reasons: self.reasons,
			meta: self.meta,
		}
	end

	def to_json(*args)
		to_hash.to_json(*args)
	end
end
